"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsolationLevel = void 0;
/**
 * Enumeration that represents transaction isolation levels for use with the {@link Transactional} annotation
 */
var IsolationLevel;
(function (IsolationLevel) {
    /**
     * A constant indicating that dirty reads, non-repeatable reads and phantom reads can occur.
     */
    IsolationLevel["READ_UNCOMMITTED"] = "READ UNCOMMITTED";
    /**
     * A constant indicating that dirty reads are prevented; non-repeatable reads and phantom reads can occur.
     */
    IsolationLevel["READ_COMMITTED"] = "READ COMMITTED";
    /**
     * A constant indicating that dirty reads and non-repeatable reads are prevented; phantom reads can occur.
     */
    IsolationLevel["REPEATABLE_READ"] = "REPEATABLE READ";
    /**
     * A constant indicating that dirty reads, non-repeatable reads and phantom reads are prevented.
     */
    IsolationLevel["SERIALIZABLE"] = "SERIALIZABLE";
})(IsolationLevel = exports.IsolationLevel || (exports.IsolationLevel = {}));
//# sourceMappingURL=isolation-level.js.map