import { DataSourceName } from '../common';
import { IsolationLevel } from '../enums/isolation-level';
import { Propagation } from '../enums/propagation';
export interface WrapInTransactionOptions {
    /**
     * For compatibility with `typeorm-transactional-cls-hooked` we use `connectionName`
     */
    connectionName?: DataSourceName;
    propagation?: Propagation;
    isolationLevel?: IsolationLevel;
    name?: string | symbol;
}
export declare const wrapInTransaction: <Fn extends (this: any, ...args: any[]) => ReturnType<Fn>>(fn: Fn, options?: WrapInTransactionOptions) => Fn;
